!-------------------------------------------------------------------------------
!
! NAME:
!   Type_Kinds
!
! FUNCTION:
!   Module to hold specification kinds, with parameter attributes, for
!   variable declarations.
!
! DESCRIPTION:
!   Define type kinds for these specific variable types:
!    Byte   - Specification kind for byte integer variable
!    Short  - Specification kind for short integer variable
!    Long   - Specification kind for long integer variable
!    DLong  - Specification kind for double long integer variable
!    Single - Specification kind for single precision real variable
!    Double - Specification kind for double precision real variable
!
! REFERENCE:
!
! CALLING SEQUENCE:
!   USE Type_Kinds
!
! INPUTS:
!
! OUTPUTS:
!
! DEPENDENCIES:
!
! RESTRICTIONS:
!
! HISTORY:
!   1998/06/17 19:54:55  walterw - Initial revision
!
!   1997/12/01 20:21:50  paulv   - Initial revision
!
!-------------------------------------------------------------------------------

MODULE Type_Kinds
 
  IMPLICIT NONE 
 
  INTEGER, PARAMETER :: BYTE   = SELECTED_INT_KIND(1)
  INTEGER, PARAMETER :: SHORT  = SELECTED_INT_KIND(4)
  INTEGER, PARAMETER :: LONG   = SELECTED_INT_KIND(8)
  INTEGER, PARAMETER :: DLONG  = SELECTED_INT_KIND(10)
  INTEGER, PARAMETER :: SINGLE = SELECTED_REAL_KIND(6)
  INTEGER, PARAMETER :: DOUBLE = SELECTED_REAL_KIND(12)

END MODULE Type_Kinds
