#!/bin/sh
# File MKPROB-SINGLE.sh
# This shell script export the arguments and use the MCENV to call the Perl script to save
#       GIF files for eTRaP
# Usage:  MKPROB-SINGLE.sh <Mcidas data Dir> < Product area number > < The order # of the product>
#                    <GIF Prefix> <EtrapFcstString>
# Notes: the area number is recommended to use 0275
#
# Author: Jianbin Yang/PSGS   March 2009
################################################################################

if [ $# -eq 5 ]
then
   dataDir=$1
   stArea=$2
  
else
   echo "ERROR: Command line format incorrect."
   echo "Command line format:"
   echo "MKPROB-SINGLE.sh <Mcidas data Dir> < Product area 1> < The order # of product>"
   echo "           <GIF Prefix> <EtrapFcstString>"
   exit 1
fi

dataDir=$1
areaNum1=$2
prodsNum=$3
gifPre=$4
fcstStr=$5

export dataDir areaNum1 prodsNum gifPre fcstStr

PATH=$PATH:$HOME/mcidas/bin:$HOME/mcidas/pctrap-V3:/home/mcidas/bin:

#echo $PATH
export PATH

# MCPATH=/home/oper/mcidas/data:/home/mcidas/data
# export MCPATH

cd $dataDir

#mcenv -f 12@455x640  -graphicsColors 16 << 'EOF'
#mcenv -i 220 -g 32 -f 10@480x640 << 'EOF'
mcenv -i 220 -g 32 -f 10@455x640 << 'EOF'
   vg06_1=66
   vg06_2=76
   vg24_1=62
   vg24_2=72

   #latLon=`imglist.k LOC/POS.$areaNum1 |grep "$areaNum1 " | awk '{print $7 " " $8}'`
   #echo "latLon is $latLon"

   #count=1
   count=$prodsNum
#   while test $count -le $prodsNum
#   do
      frmNum=$count
      gifName=$gifPre$frmNum'.GIF'
      #inAreaNum=`expr $areaNum1 + $count - 1`
      #let inAreaNum=$areaNum1+$count-1
      inAreaNum=$areaNum1

      let aNum1=$inAreaNum-100
      let aNum2=$inAreaNum+100
      let aNum3=$inAreaNum+200
      let aNum4=$inAreaNum+300
      let aNum5=$inAreaNum+500

      latLon=`imglist.k LOC/POS.$inAreaNum |grep "$inAreaNum " | awk '{print $7 " " $8}'`
      memo1=`imglist.k LOC/POS.$inAreaNum FORM=MEMO | grep memo |cut -d":" -f4-5`
      dayHhmmss=`imglist.k LOC/POS.$inAreaNum |grep "$inAreaNum " | awk '{print $3 " " $4 " " $5 " " $6}'`
      dayHhmm=`echo $dayHhmmss|cut -d":" -f1-2`

      echo "latLon=$latLon, memo1=$memo1, dayHhmm=$dayHhmm"

      #imglist.k LOC/POS.$aNum5

      #echo "gifName is $gifName"
      echo "frmNum=$frmNum, inAreaNum=$inAreaNum, aNum1=$aNum1, aNum2=$aNum2, aNum5=$aNum5"
      

      #------------ Save the QPF files ------------# 
      
      echo "count is $count"

      if [ $count -le 2 ]
      then 
         echo "Save QPF images"
         echo " "
         if [ $fcstStr -lt 24 ]
         then
            vg1=$vg06_1
            vg2=$vg06_2
         elif [ $fcstStr -eq 24 ]
         then
            vg1=$vg24_1
            vg2=$vg24_2
         else
            echo "ERROR:unexpected forecast string:$fcstStr, exit program"
            exit 1
         fi

         #--- Save the QPF files ---# 

         sf.k $count
         sg.k $count
         erase.k F
         gu.k REST WEB 

         imgdisp.k LOC/POS.$inAreaNum  LATLON=$latLon MAG=1 EU=SSTRAP20
         #imgdisp.k LOC/POS.$inAreaNum  LATLON=$latLon MAG=-2 EU=SSTRAP20
         #FRMLABEL LEV=255 254 "%6 %7 24 HR RAINFALL POTENTIAL - (DAY) (HHMM)
         bar.k ORI=HOR
         eg.k
         map.k NAME=OUTLHRES PRO=SAT
         map.k NAME=OUTLHPOL PRO=SAT
         map.k NAME=PACIFICA PRO=SAT
         map.k H
         map.k LALO INT=5 5
         showvg.k $vg1
         showvg.k $vg2
         nlogo.k
         #setMemoStr.sh $inAreaNum
         #frmlabel.k LEVE=0 255 \"eTRaP for storm #MEMO1, (DAY) (HHMM)
         #frmlabel.k LEVE=0 255 \"eTRaP for storm $memo1, $dayHhmm
         frmlabel.k LEVE=0 255 \"$dayHhmm $memo1 ETRAP
         frmsave.k $count $gifName

      #------------ Save the Probability files ------------#
     
      else
         echo "Save Probability images"
         echo " " 
         sf.k $count
         erase.k F
         gu.k REST PROBN
         gu.k OFF 3
         # IMGDISP LOC/POS.203 LATLON=%1 %2 MAG=-2 EU=PROBN
         imgcopy.k LOC/POS.$inAreaNum LOC/POS.$aNum1 LATLON=$latLon SIZE=960 1280
         imgcopy.k LOC/POS.$aNum1 LOC/POS.$aNum2 SIZE=ALL
         imgremap.k BASEMAP/LSMASK LOC/POS.$aNum2 MAG=-3
         imgoper.k LOC/POS.$aNum1 LOC/POS.$aNum3 SIZE=ALL LLMT=9
         imgoper.k LOC/POS.$aNum2 LOC/POS.$aNum4 ACON=200 SIZE=ALL
         imgoper.k LOC/POS.$aNum3 LOC/POS.$aNum4 LOC/POS.$aNum5 SIZE=ALL FORM=CMIN ZERO=DATA
         #imgdisp.k LOC/POS.$aNum5 LATLON=$latLon MAG=-2 EU=PROBN
         imgdisp.k LOC/POS.$aNum5 LATLON=$latLon MAG=1 EU=PROBN
         map.k X 11
         map.k NAME=OUTLHRES PRO=SAT
         map.k NAME=OUTLHPOL PRO=SAT
         map.k H
         map.k LALO INT=5 5 LAB=X 5 14 X
         showvg.k 2001
         nlogo.k
         #setMemoStr.sh $inAreaNum
         #frmlabel.k LEVE=0 255 \"eTRaP for storm #MEMO1, (DAY) (HHMM)
         frmlabel.k LEVE=0 255 \"$dayHhmm $memo1 ETRAP
         frmsave.k $count $gifName
      fi  

#      let count=$count+1
#   done

EOF

echo 'end of Script'

exit

