#!/usr/bin/perl -w

## =====================================================================
## Name:        cleanLogs.pl  
##                  
## Author:      Jianbin Yang/PSGS   06/10/2009
## Language:    Perl
## Purpose:     This program will clean up the monitor log filed locally
##
## Last Modified:   06/10/2009
##
## =====================================================================


# Define the directories and files
$etrapLogDir = '/data/TRAP/ETRAP/logs';           
#$monitorLogDir = "$etrapLogDir/monitorLogs";           
$monitorLogDir = "monitorLogs";           

#$deletedDays = 10.0;
$deletedDays = 60.0;

##--------------------------------- Start --------------------------------------##

$startdate=`date`;
print "Start  $0 at $startdate \n";

chdir("$etrapLogDir") || die "Cannot change to directory $etrapLogDir: $!";
print  "ETRAP Log directory is:";
system("pwd");

##-------- Clean the eTraP log file files  --------##

@fileDirList = `ls`;

foreach $fileDir (@fileDirList)
{
   chop($fileDir);
      
   if ((-f $fileDir) && ($fileDir =~ /^etrap.*log$/))
   {
      if (-M $fileDir > $deletedDays)
      {
        # unlink("$fileDir") || die "cannot unlink $fileDir: $!";
         print "$fileDir is deleted.\n";
      }
   }
   elsif ((-d $fileDir) && ($fileDir eq $monitorLogDir))
   {
      print "Clean the monitoring log file in $monitorLogDir directory.\n";
      chdir("$fileDir") || die "Cannot change to directory $fileDir: $!";
      system("pwd");
      @fileList = `ls`;

      foreach $file (@fileList)
      {
         chop($file);
         
         # Only clean the logs, but not the status file    
         if ((-f $file) && ($file =~ /\.log$/))
         {
            if (-M $file > $deletedDays)
            {
               #unlink("$file") || die "cannot unlink $file: $!";
               print "$file is deleted.\n";
            }
         }
      }  # End of the third Foreach loop

      chdir("..") || die "Cannot change to upper directory: $!";
 
   }     # End of the if/elsif 
}        # End of the Foreach loop 


print "End of clean old TRAP data\n";

