#!/bin/bash
# File :installETRAP.sh
# This shell script install the Ensemble TRaP package
#
# Author: Jianbin Yang/PSGS
# Last Modified: 04/21/2010
#
################################################################################

mcidasSrc=$HOME/mcidas/src
mcidasData=$HOME/mcidas/data
trapData=/data/TRAP

# The following directries are for ETRAP
etrapHome=$HOME/mcidas/etrap
etrapSrc=$etrapHome/src
etrapScript=$etrapHome/scripts

etrapData=$trapData/ETRAP
landSeaDir=$trapData/mcbasemaps
etrapLog=$etrapData/logs
etrapMonLog=$etrapLog/monitorLogs
etrapAREA=$etrapData/AREA
etrapDigData=$etrapData/digitETRAP
etrapNCDC=$etrapData/NCDC_Arch

# Create the Fortran executable for digital eTRaP converter

echo "Create the Fortran executable for digital eTRaP converter..."
cd $mcidasSrc
make -f makefile.digitETRAP install

# Create the eTRaP Fortran90 executable

echo "Create the eTRaP Fortran90 executable..."
cd $etrapSrc
make absoft

# Create symbolic links for some batch files in mcidas/data directory

echo "Create symbolic links for some batch files in mcidas/data directory"
cd $mcidasData
ln -s $etrapScript/INITPROB.MCB INITPROB.MCB
ln -s $etrapScript/PROB.MCB PROB.MCB
ln -s $etrapScript/runProbIni.sh runProbIni.sh
ln -s $etrapScript/runProb.sh runProb.sh
ln -s $etrapScript/MKPROBS.sh MKPROBS.sh

# Set up the Mcidas color tables for eTRaP
echo "Set up the Mcidas color tables for eTRaP"
cd $mcidasData
runProbIni.sh 

# Set up the land sea mask dataset
echo "Set up the land sea mask dataset"
dsserve.k ADD BASEMAP/LSMASK AREA DIRFILE=$landSeaDir/land_sea_mask

# Set up the directories

echo "Set up the directries"
[ -d ${etrapData} ] || mkdir ${etrapData}
[ -d ${landSeaDir} ] || mkdir ${landSeaDir}
[ -d ${etrapLog} ] || mkdir ${etrapLog}
[ -d ${etrapMonLog} ] || mkdir ${etrapMonLog}
[ -d ${etrapAREA} ] || mkdir ${etrapAREA}
[ -d ${etrapDigData} ] || mkdir ${etrapDigData}
[ -d ${etrapNCDC} ] || mkdir ${etrapNCDC}

