#!/usr/bin/perl -w

## =====================================================================
## Name:        regenGIF.pl
##                  
## Author:      Jianbin Yang/PSGS   10/30/2009
## Language:    Perl
## Purpose:     Call the batch files to regenerate the GIF for QPF
##                  
## Usage:       regenGIF.pl <etrap Regen Dir> <storm name> [<basin>]
##
## Modified:  10/30/2009
## 
## =====================================================================

#use Time::HiRes qw(sleep);  #not installed

# Define the directories and files

$HOME = $ENV{"HOME"};
$dataDir = "$HOME/mcidas/data";
$trapDataDir = '/data/TRAP';          # the actual directory is '/data/TRAP/$year/$stormNameNNB'
$etrapSrcDir = "$HOME/mcidas/etrap/scripts";
$gifCmd = "$etrapSrcDir/MKPROB-SINGLE.sh";
$gifLogPre = "$trapDataDir/ETRAP/2009/logs18/mketrap18Gif";
$gifPrefix = 'REGENETP';
$startdate=`date`;

print "Start  $0 at $startdate \n";

chdir("$dataDir") || die "Cannot change to directory $dataDir";
print  "Data directory is:";
system("pwd");

# remove the path from the command name

@comandFields = split(/\//, $0);
$commandName = $comandFields[-1];

# if no argument input, exit the program

# if ($ARGV[0] eq "")
if ($#ARGV < 1)
{
   print "Usage: $commandName <etrap Regen Dir> <storm name> [<basin>]\n";
   die "No name input - exit script";
}

$etrapRegenDir = $ARGV[0];
$stormName = $ARGV[1];

print "etrapRegenDir is $etrapRegenDir, stormName is $stormName.\n";

chdir("$etrapRegenDir/$stormName") || die "Cannot change to regenStormDir $etrapRegenDir/$stormName";

@list=`ls  -t *$stormName*.pmqpf.*18` ;
chomp(@list);

$gifLog = $gifLogPre . '.' . $stormName . ".log";

foreach $filename  (@list)
{ 
   system("cp $filename $dataDir/AREA0275");
   system("$gifCmd  $dataDir 275 2 $gifPrefix 18 >> $gifLog 2>&1");
   $tmpGif = $gifPrefix . '2' . '.GIF';
   $gifName = $filename . ".GIF";
   rename("$dataDir/$tmpGif", $gifName) or die "can't rename $tmpGif to $gifName: $!";
   unlink("$dataDir/AREA0275");
   unlink("$dataDir/$tmpGif");
   #sleep(0.5);  # use with the module HiRes, if less than 1 second
   sleep(1);

print "filename is $filename, gifName is $gifName\n";
}

$endDate = `date`;
print "End of the program $0 for $stormName at $endDate\n";
