#!/bin/bash
###############################################################################
# File :  startup.sh
#
# Author: Jianbin Yang/PSGS   May 2009
#
# Purpose: This is the start up script for eTRaP to export the 
#          common paths and valiables 
#
# Usage: . ./startup.sh
#
# Modified : 05/20/2009
#
################################################################################

Mdhm=`date +%m%d%H%M`

trapDataDir=/data/Petrap
etrapDataDir="$trapDataDir/data/ETRAP"
etrapDigDir="$etrapDataDir/digitETRAP"
logDir="$etrapDataDir/logs"
monLogDir="$logDir/monitorLogs"

trapSrcDir=$HOME/mcidas/pctrap-V3
etrapSrcDir=$HOME/mcidas/etrap/scripts
etrapBinDir=$HOME/mcidas/etrap/bin

#
# Inform the status monitor we are staring 
# will export them if they are used in the sub programs
#
status_file_stList="$monLogDir/get_storm_list.status"
status_file_gen="$monLogDir/etrap_creation.status"
status_file_img="$monLogDir/image_generation.status"
status_file_dist="$monLogDir/etrap_distribution.status"
status_file_distNCDC="$monLogDir/etrap_distributionNCDC.status"

# Main Log files
logFile="$logDir/etrap.$Mdhm.log"

# Log files for different processes, which corresponding to the above status files
logfile_stList="$monLogDir/get_storm_list.$Mdhm.log"
logfile_gen="$monLogDir/etrap_creation.$Mdhm.log"
logfile_img="$monLogDir/image_generation.$Mdhm.log"
logfile_dist="$monLogDir/etrap_distribution.$Mdhm.log"
logfile_distNCDC="$monLogDir/etrap_distributionNCDC.$Mdhm.log"

export Mdhm
export trapDataDir etrapDataDir etrapDigDir logDir monLogDir trapSrcDir etrapSrcDir etrapBinDir
export logFile logfile_stList logfile_gen logfile_img logfile_dist logfile_distNCDC
