#! /bin/sh
# SECOND VERSION
# This script automates RCS check-in process for multiple files.
# It will create the RCS directory if not existed and make a soft link from
# the current directory to it.
# It also prompts the users for a log message and automatically adds that
# message to every file checked in.
# Programmer: Trung Le
# Date: 11/28/06
#

if [ $# -eq 0 ]
then
        echo "Usage: ckin files (*.pl, *.for, *.c, etc.)" 1>&2
        exit 1
fi


for file in $@
do

  # if grep indicates the keyword $Id: addBang.sh,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $ is not present, add the keywords
  #grep -q '$Id' $file
  #if [ $? -eq 1 ]
  #    then

      # Check To see if Fortran File
      echo "$file" | grep -q '\(.f\|.for\|.pgm\|.fp\|.inc\|.dlm\)'
      if [ $? -eq 0 ]
          then
          echo "C" > result
          echo "C \$Id\$" >> result
          echo "C \$Log\$" >> result
	  echo "C" >> result
      fi

      # Check To see if C File
      echo "$file" | grep -q '\(.c\|.cp\|.cc\|.cpp\|.h\)'
      if [ $? -eq 0 ]
          then
          echo "//" > result
          echo "// \$Id\$" >> result
          echo "// \$Log\$" >> result
          echo "//" >> result
      fi

      # Check To see if a Perl File or a Script File
      echo "$file" | grep -q '\(.pl\)' || ! echo "$file" | grep -q '\(.\)' ||
      echo "$file" | grep -q '\(.sh\)'
      if [ $? -eq 0 ]
          then
          echo "#!/usr/bin/perl -w" > result
          echo "#" >> result
          #echo "# \$Id\$" >> result
          #echo "# \$Log\$" >> result
          #echo "#" >> result
      fi

      cat result $file > tempfile
      rm -f result
      mv -f tempfile $file
      chmod 755 $file

  #fi
done

# Prompt users for a log message
#echo "Please enter a log message for the check-in."
#read message

# Check in the files
# -t- prevents the initial check-in from asking for input from standard input
# -m prevents subsequent check-ins from asking for input from standard input
# -u keeps the working files

#ci -u -t- -m"$message" $*

exit 0
# End of Script
