

####------------------------------------------------------------------------------------------------####


##%%%%%%%%%%%%%%%%%%%%%%%% Subroutines %%%%%%%%%%%%%%%%%%%%%%%%##


###############  Subroutine "getBasin" #################
########################################################

sub getBasin
{
   my($wmoHd, $station, $lat, $lon) = @_;
   my($i);
 
   print "Get the basin of the bulletin $wmoHd $station in $lat/$lon (regular longitude)\n"; 
  
   #----------- Atlantic -----------#

   if ($wmoHd =~ /^WTNT2/)
   {
      print "This will send to TPC\n";
      if ($basin eq "")
      {
         $basin = $basinTbl{$Atlantic_dir};
      }

      @emailList = $AtlanticList;
      $subDir = $Atlantic_dir;
      $basinArea = $Atlantic_dir;
   }

   #----------- East Pacific -----------#

   elsif($wmoHd =~ /^WTPZ2/)
   {
      print "This will send to TPC\n";
      if ($basin eq "")
      {
         $basin = $basinTbl{$EastPacific_dir};
      }

      @emailList = $TPCList;
      $subDir = $EastPacific_dir;
      $basinArea = $EastPacific_dir;
   }

   #----------- Central Pacific -----------#

   elsif($wmoHd =~ /^WTPA2/)
   {
      print "This will send to CPHC\n";
      if ($basin eq "")
      {
         $basin = $basinTbl{$CentralPacific_dir};
      }
                                
      @emailList = $CPHCList;
      $subDir = $CentralPacific_dir;
      $basinArea = $CentralPacific_dir;
   }

   #----------- NW Pacific -----------#

   elsif($wmoHd =~ /^WTPN3/)
   {
      print "This will send to MWO Guam\n";
      $basin = $basinTbl{$NorthwestPacific_dir};
      @emailList = $NWPacificList;
      $subDir = "$NorthwestPacific_dir/JTWC";
      $basinArea = $NorthwestPacific_dir;
   }

   # station ID of FKPQ30 is also RJTD.  06/28/2007 
   elsif(($wmoHd =~ /^WTJP2/) || ($wmoHd =~ /^FKPQ3/))		
   {
      print "This will send to Tokyo\n";
      $basin = $basinTbl{$NorthwestPacific_dir};
      @emailList = $NWPacificList;
      $subDir = "$NorthwestPacific_dir/Tokyo";
      $basinArea = $NorthwestPacific_dir;
   }


   #----------- North Indian -----------#

#   elsif( (($wmoHd =~ /^WTIO3/) && ($station eq "PGTW"))
#          || ($wmoHd =~ /^WTIN/)
#          || ($wmoHd =~ /^FKIN/) )  
   elsif(($wmoHd =~ /^WTIO3/) && ($station eq "PGTW"))
   {
      print "This will send to RSMC New Delhi\n";
      $basin = $basinTbl{$NorthIndian_dir};
      @emailList = $NewDelhiList;

      $subDir = "$NorthIndian_dir/JTWC";
      $basinArea = $NorthIndian_dir;
   }

   # FKIN20 VIDP, WTIN20 DEMS, stations are different, will check, and may need to modify the createTRaPDir for agency name
   elsif(($wmoHd =~ /^WTIN/) || ($wmoHd =~ /^FKIN/))
   {
      print "This will send to RSMC New Delhi\n";
      $basin = $basinTbl{$NorthIndian_dir};
      @emailList = $NewDelhiList;
      $subDir = "$NorthIndian_dir/NewDelhi";
      $basinArea = $NorthIndian_dir;
   }


   ##----------- JTWC bulletins - WTXS -----------##

   # The TRaP from JTWC bulletin will alert no people, so the emailList is empty
   # except the WTIO31 and WTPN31, Maybe change in the future
   
   elsif(($wmoHd =~ /^WTXS3/) && ($station eq "PGTW"))
   {
      if ($lon < 90)
      {
         print "This will send to RSMC Reunion\n";
         $basin = $basinTbl{$SouthwestIndian_dir};
         $subDir = "$SouthwestIndian_dir/JTWC";
         $basinArea = $SouthwestIndian_dir;
         push(@emailList, $ReunionList);
         if ($lon >= 85)
         {
            push(@emailList, $PerthList);
         }                 
      }
      #elsif (($lon >= 90) && ($lon < 130))
      elsif (($lon >= 90) && ($lon < 125))
      {
         print "This will send to RSMC Perth\n";
         $basin = $basinTbl{$SoutheastIndian_dir};
         $subDir = "$SoutheastIndian_dir/JTWC";
         $basinArea = $SoutheastIndian_dir;
         push(@emailList, $PerthList);
         if ($lon < 95) 
         {
            push(@emailList, $ReunionList);
         }
         elsif ($lon >= 120)
         {
            push(@emailList, $DarwinList);
         }
      }
      #elsif (($lon >= 130) && ($lon < 142))
      elsif (($lon >= 125) && ($lon < 142))
      {
         print "This will send to RSMC Darwin\n";
         $basin = $basinTbl{$NorthernTerritory_dir};     
         $subDir = "$NorthernTerritory_dir/JTWC";   
         $basinArea = $NorthernTerritory_dir;   
         @emailList = ($DarwinList, $PerthList, $BrisbaneList);
 #        if ($lon < 140)
  #       {
   #         $emailList = $emailList . " " . $PerthList;
    #     }
      }
   }   	# End of bulletin WTXS31-35 (PGTW)


   ##----------- Reunion bulletins -----------##

   # elsif(($wmoHd =~ /^WTIO/) && ($station eq "FMEE") && ($lon < 90))   # WTIO30 ?
   elsif( (($wmoHd =~ /^WTIO/) || ($wmoHd =~ /^FKIO/)) && ($station eq "FMEE") && ($lon < 90))   # WTIO30 ?
   {
      print "This will send to RSMC Reunion\n";
      $basin = $basinTbl{$SouthwestIndian_dir};
      @emailList = $ReunionList;
      $subDir = "$SouthwestIndian_dir/Reunion";
      $basinArea = $SouthwestIndian_dir;
      if  ($lon >= 85)
      {
         push(@emailList, $PerthList);
      }
   }

   ##----------- Australian bulletins -----------##   

   # elsif($wmoHd =~ /^WTAU0/) 
   elsif($wmoHd =~ /^AXAU/)
   {
      $tempWmo = $wmoHd;
      $lastDigit = chop($tempWmo);
  
      # For "WTAU05", 06, 07
    ##  if (($lastDigit >= 5) && ($station eq "APRF") && ($lon >= 80) && ($lon <= 140))
    ##  if (($lastDigit >= 5) && ($station eq "APRF") && ($lon >= 90) && ($lon < 130))
    #  if (($lastDigit >= 5) && ($station eq "APRF"))
      if ($station eq "APRF")
      {
         print "This will send to RSMC Perth\n";
         $basin = $basinTbl{$SoutheastIndian_dir};         # SE Indian Ocean
         @emailList = $PerthList;
         $subDir = "$SoutheastIndian_dir/Perth";
         $basinArea = $SoutheastIndian_dir;
         if ($lon < 95)
         {
            push(@emailList, $ReunionList);
         }
         elsif ($lon >= 120)
         {
            push(@emailList, $DarwinList);
         }
      }
      # For "WTAU03", 04, 
    ##  elsif (($lastDigit <= 4) && ($station eq "ADRM") && ($lon >= 120) && ($lon <= 152))
     ## elsif (($lastDigit <= 4) && ($station eq "ADRM") && ($lon >= 130) && ($lon < 142))
      ## change on 03/17/04
     ## elsif (($lastDigit <= 4) && ($station eq "ADRM") && ($lon >= 125) && ($lon < 142))
     # elsif (($lastDigit <= 4) && ($station eq "ADRM"))
      elsif ($station eq "ADRM")
      {
         print "This will send to RSMC Darwin\n";
         $basin = $basinTbl{$NorthernTerritory_dir};         # Northern Territory

         # The TRaP in Northern Territory will send to other two agents:Perth and Brisbane
         @emailList = ($DarwinList, $PerthList, $BrisbaneList);
         $subDir = "$NorthernTerritory_dir/Darwin";
         $basinArea = $NorthernTerritory_dir;
      }
   }	 # End of the bulletin "AXAU"

   # elsif ((($wmoHd eq "WOAU01") || ($wmoHd eq "WOAU02")) && ($station eq "ABRF") 
   #       && ($lon > 132) && ($lon <= 170)) 
   #          && ($lon >= 142) && ($lon < 160))
   #elsif (($wmoHd =~ /^WOAU0/) && ($station eq "ABRF"))
   elsif ($station eq "ABRF")
   {  
      print "This will send to RSMC Brisbane\n";
      $basin = $basinTbl{$SouthwestPacific_dir};         # SW Pacific
      @emailList = $BrisbaneList;
      $subDir = "$SouthwestPacific_dir/Brisbane";
      $basinArea = $SouthwestPacific_dir;
      if ($lon < 152)
      {
         push(@emailList, $DarwinList);
      }
      elsif ($lon >= 155)
      {
        # if ($lat >= -15)
        # {

            push(@emailList, $NadiList);

        # }
        # elsif (($lat < -15) && ($lat >= -35))
        # {
        #    push(@emailList, $NadiList, $OtherList);
        # }
        # else
        # {
        #    push(@emailList, $OtherList);
        # }

      }
   }	 # End of the bulletin "AXAU"


   ##----------- ICAO Australian bulletin -----------##

   elsif($wmoHd =~ /^FKAU0/)
   {
      if (($lon >= 90) && ($lon < 125))
      {
         print "This will send to ICAO Perth\n";
         $basin = $basinTbl{$SoutheastIndian_dir};
         $subDir = "$SoutheastIndian_dir/Perth";
         $basinArea = $SoutheastIndian_dir;

         @emailList = $PerthList;
         if ($lon < 95)
         {
            push(@emailList, $ReunionList);
         }
         elsif ($lon >= 120)
         {
            push(@emailList, $DarwinList);
         }
      }
      elsif (($lon >= 125) && ($lon < 142))
      {
         print "This will send to ICAO Darwin\n";
         $basin = $basinTbl{$NorthernTerritory_dir};         # Northern Territory
         $subDir = "$NorthernTerritory_dir/Darwin";
         $basinArea = $NorthernTerritory_dir;

         # The TRaP in Northern Territory will send to other two agents:Perth and Brisbane
         @emailList = ($DarwinList, $PerthList, $BrisbaneList);
      }
      elsif (($lon >= 142) && ($lon <= 160))
      {
         print "This will send to ICAO Brisbane\n";
         $basin = $basinTbl{$SouthwestPacific_dir};         # SW Pacific
         $subDir = "$SouthwestPacific_dir/Brisbane";
         $basinArea = $SouthwestPacific_dir;

         @emailList = $BrisbaneList;
         if ($lon < 152)
         {
            push(@emailList, $DarwinList);
         }
         elsif ($lon >= 155)
         {
           # if ($lat >= -15)
           # {

               push(@emailList, $NadiList);

           # }
           # elsif (($lat < -15) && ($lat >= -35))
           # {
           #    push(@emailList, $NadiList, $OtherList);
           # }
           # else
           # {
           #    push(@emailList, $OtherList);
           # }
         }
      }	# End of elsif for Brisbane

   }	# End of if for FKAU


   ##----------- Fiji bulletin -----------##

   # elsif(($wmoHd =~ /^WTPS0/) && ($station eq "NFFN") &&
   #elsif(($wmoHd =~ /^W.PS0/) && ($station eq "NFFN") &&
   #      (($lon >= 160) || ($lon < 0)) && ($lat >= -25))

   # modified on 04/06/07, for CLIFF, "WTPS01 NFFN in -26.00/-171.5"
   #elsif(($wmoHd =~ /^W.PS0/) && ($station eq "NFFN") &&
   elsif( (($wmoHd =~ /^W.PS0/) || ($wmoHd =~ /^FKPS/)) && ($station eq "NFFN") &&
         (($lon >= 160) || ($lon < 0)) )
   {
      print "This will send to RSMC Nadi\n";
      $basin = $basinTbl{$SoutheastPacific_dir};
      @emailList = $NadiList;
      $subDir = "$SoutheastPacific_dir/Fiji";
      $basinArea = $SoutheastPacific_dir;
      if ($lon < 165)
      {
         push(@emailList, $BrisbaneList);
      }
   }


   ##----------- JTWC bulletins - WTPS3X -----------##

   elsif(($wmoHd =~ /^WTPS3/) && ($station eq "PGTW"))
   {
      #if (($lon >= 130) && ($lon < 142))
      if (($lon >= 125) && ($lon < 142))
      {
         print "This will send to RSMC Darwin\n";
         $basin = $basinTbl{$NorthernTerritory_dir};         # Northern Territory
         $subDir = "$NorthernTerritory_dir/JTWC";
         $basinArea = $NorthernTerritory_dir;
         @emailList = ($DarwinList, $PerthList, $BrisbaneList);
 #        if ($lon >= 132)
  #       {
   #         $emailList = $emailList . " " . $BrisbaneList;
    #     }
      }
      elsif (($lon >= 142) && ($lon < 160))
      {
         print "This may send to RSMC Brisbane\n";
         $basin = $basinTbl{$SouthwestPacific_dir};         # SW Pacific
         $subDir = "$SouthwestPacific_dir/JTWC";
         $basinArea = $SouthwestPacific_dir;
         @emailList = $BrisbaneList;
         if ($lon < 152)
         {
            push(@emailList, $DarwinList);
         }
         elsif ($lon >= 155)
         {
           # if ($lat >= -15)
           # {

               push(@emailList, $NadiList);

           # }
           # elsif (($lat < -15) && ($lat >= -35))
           # {
           #    push(@emailList, $NadiList, $OtherList);
           # }
           # else
           # {
           #    push(@emailList, $OtherList);
           # }
         }
      }
      #elsif ((($lon >= 160) || ($lon < 0)) && ($lat >= -25))
      elsif (($lon >= 160) || ($lon < 0))
      {
         print "This may send to RSMC Nadi\n";
         $basin = $basinTbl{$SoutheastPacific_dir};         # SE Pacific
         $subDir = "$SoutheastPacific_dir/JTWC";
         $basinArea = $SoutheastPacific_dir;
         @emailList = $NadiList;
         if ($lon < 165)
         {
            push(@emailList, $BrisbaneList);
         }
         ## if ($lat < -15)
         #if ($lat < -20)
         #{
         #   push(@emailList, $OtherList);
         #   print "\nPAY ATTENTION!! The storm is in south of -20 in Southeast Pacific (Near New Zealand Area).\n";
         #}

      }

#      elsif ((($lon >= 160) || ($lon < 0)) && ($lat < -25))
#      {
#         print "This may send to Other\n";
#         $basin = $Other_basin;         # SE Pacific
#         $subDir = "$SoutheastPacific_dir/JTWC";
#         $basinArea = $SoutheastPacific_dir;
#         @emailList = $OtherList;
#         if ($lon < 165)
#         {
#            push(@emailList, $BrisbaneList);
#         }
#         if ($lat > -35)
#         {
#            push(@emailList, $NadiList);
#         }
#      }

   }    # End of the bulletin "WTPS31-35 (PGTW)


   ##----------- New Zealand bulletins - WTNZ -----------##

   # WTNZ or WHNZ
   elsif(($wmoHd =~ /^W[T,H]NZ/) )
   {
      if ($lon < 160)
      {
         print "This may send to RSMC Brisbane/Wellington\n";
         $basin = $basinTbl{$SouthwestPacific_dir};         # SW Pacific
         $subDir = "$SouthwestPacific_dir/Wellington";
         $basinArea = $SouthwestPacific_dir;
         @emailList = $BrisbaneList;
         if ($lon < 152)
         {
            push(@emailList, $DarwinList);
         }
         elsif ($lon >= 155)
         {
               push(@emailList, $NadiList);

         }
      }
      elsif (($lon >= 160) || ($lon < 0))
      {
         print "This may send to RSMC Nadi/Wellington\n";
         $basin = $basinTbl{$SoutheastPacific_dir};         # SE Pacific
         $subDir = "$SoutheastPacific_dir/Wellington";
         $basinArea = $SoutheastPacific_dir;
         @emailList = $NadiList;
         if ($lon < 165)
         {
            push(@emailList, $BrisbaneList);
         }

      }
   }    # End of the bulletin "WTNZ/WHNZ"

}	# End of the subroutine "getBasin"
