#
# $Id: cleanPass.sh,v 1.2 2011-01-20 21:04:22 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:56:36  oper1
# First checkin.
#
#
#!/bin/bash

###############################################################################
# Name: cleanPass.sh
#
# This shell script cleans up the previous 24 hours's AMSU/TRMM/SSMI pass
# data file.  This script will run at 0:00 AM everyday.
# note that: the name for amsub file is : amsub.Dyyjjj.Shhmm.Ehhmm.NL (or NK)
#            the name for trmm is : trmm.yyyy-mm-ddThh-mm-ssZ
#            the name for ssmi is : SSGEO.EDRR.S7.D02178.S0504.E0712.B3745152.NS
#
# Author: Jianbin Yang/RSIS    May 2, 2002
# Modified: July 15, 2002
#
# Modified: Dec 10, 2006
#         Change the clean up from 24 hours to 3 days, in case SAB has questions
#         on the weedend passes/TRaP
# 
# Last Modified: Oct 3, 2007
#         Add the clean up for AMSR-E geolocation file, rewrote the script in an effective way
#
################################################################################

dataDir="/data/Petrap/data/mcidas_data"
#passDataDir = "$DATAHOME/data/mcidas_data/polerPassData"
passDataDir=$dataDir/polerPassData

# assign part of the file name for matching/grep
amsubId=amsub.D
trmmId=trmm
ssmiId=SSGEO.NPR.EDRR.S
ssmisId=GEO.EDEB.S
# amsre.Rain_V09_200710031544_D
amsreId=amsre.Rain_

# set the current data
year=`date -u '+%Y'`
month=`date -u '+%m'`
day=`date -u '+%d'`
jday=`date -u '+%j'`
hour=`date -u '+%H'`

echo " "
echo '**************** Start to clean up old pass data files ****************'
echo 'Start daily cleanup for the previous 4 days AMSU/TRMM/SSMI/AMSR-E pass data files'
echo " "
echo 'Today is: Year ' $year ' Month ' $month ' Day ' $day  ' Julian day ' $jday
echo 'Current clock hour is ' $hour ' GMT'
echo " "

# clean the previous AMSU/TRMM/SSMI/AMSR-E data file
cd $passDataDir
pwd


# count the number of the match files, if is zero, then there is no file to delete


pwd

# temporarily change to 8 days
#find .  -name "$amsubId*" -mtime +4   -exec rm {} \;
find .  -name "$amsubId*" -mtime +8   -exec rm {} \;
find .  -name "$trmmId*" -mtime +8   -exec rm {} \;
find .  -name "$ssmiId*" -mtime +8   -exec rm {} \;
find .  -name "$ssmisId*" -mtime +8   -exec rm {} \;
find .  -name "$amsreId*" -mtime +8   -exec rm {} \;


echo '**************** End of cleaning up pass data files ****************'
echo " "

exit
