#!/usr/bin/perl -w

## =====================================================================
## Name:        createSABDir.pl
##
## Author:      Jianbin Yang/Perot System   04/03/2007
## Language:    Perl
## Purpose:     Create the directories structure on the SAB data server to save all TRaP
##
## Usage:       createSABDir.pl <year> <storm name> <trap set name>
##
## Modified:   01/30/2008
##
## =====================================================================

# Define the directories and files

# $webHomeDir = "/home/sabweb/TRAP";
$trapDataDir = '/data/TRAP';          # the actual TRaP directory is '/data/TRAP/$year/$stormNameNNB'
$trapSetLog = "$trapDataDir/trapSetSab.log";

##--------------------------------- Start --------------------------------------##

$startdate=`date`;
print "Start  $0 at $startdate \n";

chdir("$trapDataDir") || die "Cannot change to directory $trapDataDir";
print  "TRaP Data directory is:";
system("pwd");

# remove the path from the command name

@comandFields = split(/\//, $0);
$commandName = $comandFields[-1];

if (@ARGV < 3)
{
   print "Usage: $commandName <year> <storm name> <TRaP Set Name>\n";
   die "Not enough arguments - exit script";
}
else
{
   $year = $ARGV[0];
   $stormName = $ARGV[1];
   $trapSetName = $ARGV[2];
}


##------------ Create the yyyy/stormName directories if not exist -------------##

if (!(-d $year))
{
   print "Create the directory '$year' for the current year.\n";
   mkdir($year,0755) || die "cannot mkdir $year: $!";
}

chdir("$year") || die "Cannot change to directory $year";

if (!(-d $stormName))
{
   print "Create the directory '$stormName' for the new storm.\n";
   mkdir($stormName,0755) || die "cannot mkdir $stormName: $!";
}

   open (LOGFILE, ">>$trapSetLog") || die " Can't seem to open $trapSetLog:$!";

   print LOGFILE "OS \"restoreAREA.pl $trapSetName\n";

   close (LOGFILE);

