#!/usr/bin/perl -w
#
#
# $Id: deleteDigDir.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#
#!/usr/bin/perl -w

## =====================================================================
## Name:        deleteDigDir.pl
##
## Author:      Jianbin Yang/Perot System   04/03/2007
## Language:    Perl
## Purpose:     delete the directories structure on the SAB data server to save digital TRaP
##
## Usage:       deleteDigDir.pl <year> <storm name>
##
## Modified:   04/03/2007
##
## =====================================================================

# Define the directories and files

# $webHomeDir = "/home/sabweb/TRAP";
$trapDataDir = '/data/TRAP/digitTRAP/test';          # the actual TRaP directory is '/data/TRAP/$year/$stormNameNNB'

##--------------------------------- Start --------------------------------------##

$startdate=`date`;
print "Start  $0 at $startdate \n";

chdir("$trapDataDir") || die "Cannot change to directory $trapDataDir";
print  "TRaP Data directory is:";
system("pwd");

# remove the path from the command name

@comandFields = split(/\//, $0);
$commandName = $comandFields[-1];

if (@ARGV < 2)
{
   print "Usage: $commandName <year> <storm name>\n";
   die "Not enough arguments - exit script";
}
else
{
   $year = $ARGV[0];
   $stormName = $ARGV[1];
}


##------------ Create the yyyy/stormName directories if not exist -------------##

if (!(-d "$year/$stormName"))
{
   die "Error!! directory $year/$stormName is not exist, please check again.\n"; 
}
else
{
   print "Remove the whole directory for $year/$stormName.\n";
   system("rm -r $year/$stormName");
}

print "End of the program to delete the storm.\n";
