#!/usr/bin/perl -w
#
#
# $Id: dsinfo.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#

#! /usr/bin/perl
#  dsinfo.pl
#
#  Script to monitor if CEMSCS datasets are filling
#
#  version- 1.0     date- 01/13/99    programmer- D. McNamara
#  version- 1.1     date- 04/16/99    programmer- D. McNamara
#                   fixed loop index for email from l to i to
#                   correct email message.
#  version- 1.2     date- 06/23/00    programmer- D. McNamara
#                   using Perl ftp's to allow clean timeouts
#***************************************************************

use Net::FTP;
use Net::Netrc;

#Get data from CEMSCS.  For now, we must move from $dmcnam path to prd.
$count=0;
while ($count <= 6) {
 $ftp=Net::FTP->new('cemscs');
 if (defined($ftp)) {last}
 $count=$count+1;
 if ($count <= 5) {
  sleep(60);
  print "trying again to connect to cemscs\n";
  next  }
 else {die "Could not connect to cemscs\n";}
}
$ftp->login();
$ftp->ascii;
$ftp->cwd('..');
$ftp->cwd('prd.ozone.r');
$ftp->get("dsinfo","/products/OZONE/data/dsinfo");
$ftp->quit;
print "finished getting files from cemscs\n";

#get the names for email notification
open(INADDRESS,'</products/OZONE/ozone_staff');
$theaddresses=<INADDRESS>;
chomp $theaddresses;
close INADDRESS;

#open file from cemscs and read in data
open(INDSINFO,'</products/OZONE/data/dsinfo');
$i=0;
while(<INDSINFO>) {
  $chk=substr($_,0,3);
  if($chk =~ /PRD/) {
    @info=split(/ /,$_);
    $fill=$info[2]*100./$info[1];
    if ($fill >= 95.) {
      $sfill=sprintf("%.1f",$fill);
      print "$sfill\n";
      push(@outds,$info[0]);
      push(@outsz,$sfill);
      print "$outds[$i] is $outsz[$i] % filled\n";
      $i++;
    }
  }
}
close INDSINFO;

print "$i\n";
#stop if all datasets are less than 95% full
if ($i == 0) { die };

#notify ozone staff
open(EMAIL,"|Mail -s 'WARNING--DATASET FILL' $theaddresses");
foreach $i (@outds) {
  print EMAIL "WARNING:  $outds[$i] is $outsz[$i] % filled!\n";
  }
close EMAIL;
