#!/usr/bin/perl -w
#
#
# $Id: ftptrap.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#
#!/usr/bin/perl -w

## =====================================================================
## Name:        ftptrap.pl  
##                  
## Author:      Jianbin Yang/RSIS   01/12/2004
## Language:    Perl
## Purpose:     This program make the tar file from all the 24 hr total TRaP
##              and bulletin of input storm and send out to FTP server.
##              A email notification will be sent to SAB analyst for report.
##
##                         
## Modified:   01/12/2004
##
## Modified: 08/18/2004
##                DNS changes for FTP server
##                (from "gp16.wwb.noaa.gov" to "gp16.ssd.nesdis.noaa.gov")
##
## Last Modified: 01/19/2006
##                Generated the tar file including the 6 hour total, it was just
##                24 hour total.
##
##
## =====================================================================


# Define the directories and files
$trapDataDir = '/data/TRAP/';          # the actual TRaP directory is '/data/TRAP/$year/$stormNameNNB'
$tempOut = '/tmp/tarout';
$sftpfile1 = '/tmp/ftpTar1';

# ftp address
$ftpServer = "gp16.ssd.nesdis.noaa.gov";
$ftpDir = "pub/TRAP/ARCH";
$ftpURL = "ftp://gp16.ssd.nesdis.noaa.gov/$ftpDir";

# initialize the arrays  

@tarList = ();

# user email address for notification
# $userAddress = "'Michael.Turk\@noaa.gov' 'SABsupervisor\@noaa.gov'";
$userAddress = "Michael.Turk\@noaa.gov";

# email lists for SAB analysts who will save the data
# $userAddress = "'Michael.Turk\@noaa.gov' 'Sheldon.Kusselson\@noaa.gov' " . 
#               " 'Otto.Karst\@noaa.gov' 'Greg.Gallina\@noaa.gov' " . 
#               " 'jianbin.yang\@noaa.gov'";

# $userAddress = "'jianbin.yang\@noaa.gov' 'Michael.Turk\@noaa.gov'";

##--------------------------------- Start --------------------------------------##
$startdate=`date`;
print "Start  $0 at $startdate \n";

if (@ARGV < 1)
{
   print "Usage: ftptrap.pl <storm name> [<storm name2>]... \n";
   print "Noted that if the storm is not for current yesr, please include the year in front of the storm name.\n";
   die "No storm name input - exit program";
}
else
{
   @stormList = @ARGV;
}

# $numOfStorm = @stormList;

# if (@stormList ne "")
# {
#   print "the storm list are @stormList, number of storms is $numOfStorm and $#ARGV\n";
# }

chdir("$trapDataDir") || die "Cannot change to directory $trapDataDir: $!";
print  "TRAP Data directory is:";
system("pwd");


$curYear = `date +%Y`;
chop($curYear);

foreach $storm (@stormList)
{
   # the oldYear will be included in the tarName. so that 
   # there is no duplicated name for the system went through two years 
   # $tarName = $storm . "-24h.tar";
   $tarName = $storm . ".tar";
   if ($storm =~ /^\d{4}\w+/)
   {
      $year = substr($storm, 0, 4);
      $storm = substr($storm, 4);
      # $storm = substr($storm, 4, (length($storm) - 4));    
   }  
   else
   {
      $year = $curYear;
   }
 
   print "the storm is $storm, the year is $year.\n";
   # $tarName = $storm . "-24h.tar";    

   # chdir ("$year/$storm") || die "Cannot change to directory $year/$storm: $!";
   chdir ("$year") || die "Cannot change to directory $year: $!";
   system("pwd");
   # system("tar cvf '$tarName' *.24.hi.Z *.bul.Z > $tempOut");
   system("tar cvf '$tarName' $storm > $tempOut");
   # system("mv $tarName ../..");
   system("mv $tarName ..");
   chdir ("$storm") || die "Cannot change to directory $storm: $!";
   $areaName =  `ls -tr *.24.Z |tail -1`;
   $gifName = `ls -tr *.24.GIF |tail -1`; 
   $bulName = `ls -tr *.bul.Z |tail -1`;
   chdir("../..") || die "Cannot change to upper directory: $!";
   push(@tarList, $tarName);
} 

print  "Current Data directory is:";
system("pwd");


##------ Send (SFTP) out the tar files to FTP server - GP16 ------##

print " Create sftp script to send the tar files @tarList to $ftpServer\n";

# the absolute remote ftp direcotry
$abs_ftpDir = "/data/ftp/" . $ftpDir;

open  ( FTPOUT1,  ">$sftpfile1" )  ||  die " Can't open $sftpfile1 to write: $!";

   print  FTPOUT1   "# SFTP command file:  Put storm tar files to FTP server\n";
   print  FTPOUT1   " sftp $ftpServer << EOF\n";
   print  FTPOUT1   "   cd  $abs_ftpDir\n";
   foreach $fileName (@tarList)
   {
      print  FTPOUT1   "   put  $fileName\n";
   }
   print  FTPOUT1   "   bye\n";
   print  FTPOUT1   "EOF\n";

close ( FTPOUT1 ) || die "Can't close $sftpfile: $!";
chmod  (0777,  $sftpfile1) ;

# Run the sftp file to send the tar files 
$enddate=`date`;
print " Start  sftp tar files to $ftpServer at $enddate \n";
open ( SFTPOUT,  " $sftpfile1  | " ) || die " Can't open $sftpfile1 to run: $!";

@sftpOutput = <SFTPOUT>;

close (SFTPOUT ) || die "Can't close $sftpfile1: $!";

# print "the sftp output is:\n@sftpOutput\n";

print "remove the tar files from locate machine\n";
`rm @tarList`;
# unlink("@tarList") || die "cannot unlink @tarList: $!";
print "Send email for tar files information.\n";

open MAIL,"|mail -s 'Tar file(s) for tropical system @stormList is sent to FTP server' $userAddress";

print MAIL "Tar file(s) @tarList for @stormList was just placed into the FTP sesrver.\n ";

print MAIL "\nThere are three types of files inside the tar file:\n";
print MAIL "(1) 6 and 24 hour total Mcidas AREA files (compressed), with file name like this:\n$areaName";
print MAIL "(2) 6 and 24 hour total GIF files, with file name like this:\n$gifName";
print MAIL "(3) The corresponding forecast bulletin for that TRaP, with file name like this:\n$bulName\n";

print MAIL "The website for this ftp server is $ftpURL. The tar file can be downloaded directly from it.\n"; 
print MAIL "If accessed by anonymous ftp.  'ftp $ftpServer' , then  'cd $ftpDir'.\n";

close MAIL;


print "End of ftp TRAP data\n";

