#!/bin/bash
# File :installTRAP.sh
# This shell script install the Automatic TRaP package
#
# Author: Jianbin Yang/RSIS    11/2002
# Last Modified: 04/19/2010
#                Set up the softlinks and directories
#
################################################################################

trapSrc=$HOME/mcidas/pctrap-V3
mcidasSrc=$HOME/mcidas/src
mcidasData=$HOME/mcidas/data
passDir=$mcidasData/polerPassData
trapData=/data/TRAP
trapLog=$trapData/log

echo "Copy the Mcidas main and library files"
cp -p ~mcidas/lib/main.o $HOME/mcidas/lib/
cp -p ~mcidas/lib/libmcidas.a $HOME/mcidas/lib/
cp -p ~mcidas/lib/libsdi.a $HOME/mcidas/lib/
cp -p ~mcidas/lib/libmcold.a $HOME/mcidas/lib/
cp -p ~mcidas/lib/main.o $trapSrc/
cp -p ~mcidas/lib/main.o $mcidasSrc/

echo "Create the C and Fortran executable for TRaP..."
cd $trapSrc
make -f makefile.dist2 install
make -f makefile.pctrp pctrp

echo "Create the Fortran executable for digital TRaP converter..."
cd $mcidasSrc
make -f makefile.src install
make -f makefile.digitTRAP install

echo "Create symbolic links for some batch files in mcidas/data directory"
# Create symbolic links for some batch files in mcidas/data directory
cd $mcidasData
ln -s $HOME/mcidas/pctrap-V3/AREAL-AUTOTRAPT AREAL-AUTOTRAPT
ln -s $HOME/mcidas/pctrap-V3/AREAL-AUTOTRAPAS AREAL-AUTOTRAPAS
ln -s $HOME/mcidas/pctrap-V3/AREAL-AUTOTRAPA AREAL-AUTOTRAPA
ln -s $HOME/mcidas/pctrap-V3/AREAL-AUTOTRAP AREAL-AUTOTRAP

echo "Set up the directries "
#Create directories for /data
[ -d ${passDir} ] || mkdir ${passDir}
[ -d ${trapLog} ] || mkdir ${trapLog}
