#!/usr/bin/perl -w
#
#
# $Id: renameTRAPFile.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#
#!/usr/bin/perl -w

## =====================================================================
## Name:        renameTRAPFile.pl
##                  
## Author:      Jianbin Yang/RSIS   01/12/2005
## Language:    Perl
## Purpose:     
##              (1).Rename the TRaP files in "year" from old name to new name,
##              (2).Modify the content of the text log file  to the correct new name
##		    in any place of the old name .
##
## Usage: 	renameTRAPFile.pl <year> <old storm name> <new storm name>\n";            
##                  
## Last Modified:   01/20/2005
##
## =====================================================================


# Define the directories and files
# $dataDir = '/home/oper/mcidas/data';
$trapDataDir = "/data/TRAP/";

$startdate=`date`;
print " Start  $0 at $startdate \n";

if (@ARGV < 3)
{
   print "Usage: $0 <year> <old storm name> <new storm name>\n";
   exit;
}
else
{
   $year = $ARGV[0];
   $oldName = $ARGV[1];
   $newName = $ARGV[2];
}

$trapDataDir .= "$year/$oldName";
 
chdir("$trapDataDir") || die "Cannot change to directory $trapDataDir";
print  "Data directory is:";
system("pwd");

# uncompress all the text log files, before the content changed
system("uncompress *.txt*");

@filelist = `ls $year*`; 
chomp(@filelist); 

#print "the file list are\n@filelist\n"; 

foreach $filename (@filelist)
{
#    print "\n*****the name is $filename\n";

    if ($filename =~ /$oldName/)
    {
       # change the content for the text log file to the new storm name
       if ($filename =~ /\.txt$/)
       {  
#          print "Change the content of the text file $filename to the new storm name.\n";
          system("sed 's/$oldName/$newName/g' $filename > temp.txt");
          system("mv temp.txt $filename")
       }

       $oldFilename = $filename;
       $filename =~ s/$oldName/$newName/;
#       print "the filename is $filename\n";      

       rename("$oldFilename", "$filename") || die "can not rename:$!";
    }

}

system("compress *.txt*");

print "End of the rename process for the current TRaP data directory.\n";



