#!/usr/bin/perl -w
#
#
# $Id: saveAUBul.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.2  2009/06/19 14:52:30  cmuser
# modified four scripts for CCR00196 (Prepare TRaP for NOAA-N'
#
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#
#!/usr/bin/perl -w

## =====================================================================
## Name:        saveAUBul.pl
##                  
## Author:      Jianbin Yang/QSS   03/09/2007
## Language:    Perl
## Purpose:     Save a couple Australian bulletins  
##                  
## Last Modified:   03/09/2007
##
## =====================================================================

# use Time::HiRes qw(sleep);

# Define the directories and files

$HOME = $ENV{"HOME"};
$dataDir = "$HOME/mcidas/data";
# $bulDir = "$dataDir/wxt/australia/compare-AX-FK-WTAU/auto";
$bulDir = '/data/TRAP/saveData/wxt/australia/compare-AX-FK-WTAU/auto';
$wxtFile = "$bulDir/wxtAU.doc";

@wmolist = qw(
   WTAU01 WTAU02 WTAU03 WTAU04 WTAU05 WTAU06 WTAU07
   WOAU01 WOAU02
   FKAU01 FKAU02 FKAU03 FKAU04 FKAU05 
   AXAU01 AXAU02 AXAU03 AXAU21 
   AXAU04 AXAU04
);

@wmolist1 = qw(
   FKAU04 
   AXAU02 AXAU21
);

$number = 10;

$startdate=`date`;
print " Start  $0 at $startdate \n";
$dateStr = `date +%m%d%y`;
chomp ($dateStr);


chdir("$dataDir") || die "Cannot change to directory $dataDir";
print  "Data directory is:";
system("pwd");



foreach $wmoid (@wmolist)
{
   print "\nThe WMO Header is $wmoid\n";

   system("wxtlist.k WMO=$wmoid DEV=T $wxtFile");

   if ((-s $wxtFile) > 33)
   {
      $wmoidLow = $wmoid;
      $wmoidLow =~ tr/A-Z/a-z/;
      $saveFile = $wmoidLow . '-' . 'n' . $number . '-' . $dateStr; 
      print "saveFile is $saveFile\n";
      $saveFile = "$bulDir/$saveFile";

      system("wxtlist.k WMO=$wmoid NUM=$number DEV=T $saveFile");
   }
   else
   {
      print "$wmoid is empty.\n";
   }

}

print "\nEnd of the Program.\n";



