#!/usr/bin/perl -w
#
#
# $Id: writeList.pl,v 1.1.1.1 2010-04-27 15:13:11 cmuser Exp $
# $Log: not supported by cvs2svn $
# Revision 1.2  2009/06/19 14:52:30  cmuser
# modified four scripts for CCR00196 (Prepare TRaP for NOAA-N'
#
# Revision 1.1.1.1  2009/02/04 19:25:09  cmuser
# initial release
#
# Revision 1.1  2007/11/30 19:57:01  oper1
# First checkin.
#
#
#!/usr/bin/perl -w

## =====================================================================
## Name:        writeList.pl
##                  
## Author:      Jianbin Yang/QSS   09/07/2006
## Language:    Perl
## Purpose:     Write the TRaP list and email to a file for the email create
##	 	script to read later
##
## Usage:       writeList.pl <TRaP Set Name> <basin Area> <emailList-Array>
##
## PLEASE NOTE: This script must be called inside "area2digit.pl"             
##                  
## Modified:   09/12/2006
##
## Last Modified: 02/06/09
##         Changed to use $HOME without specifying the oper account
##
## =====================================================================

# Define the directories and files

$HOME = $ENV{"HOME"};

# $dataDir = '/home/oper1/mcidas/data';
$dataDir = "$HOME/mcidas/pctrap-V3";
$templateFile = "$dataDir/TRaPList-template.txt";
$listFile = "$dataDir/TRaPList.txt";
$newListFile = "$dataDir/TRaPList-new.txt";
$bakListFile = "$dataDir/TRaPList-bak.txt";


@emailList = ();

# initialize the email exist hash table
%isEmailExist = ();

$startdate=`date`;
print " Start  $0 at $startdate \n";

chdir("$dataDir") || die "Cannot change to directory $dataDir";
print  "Data directory is:";
system("pwd");

# remove the path from the command name

@comandFields = split(/\//, $0);
$commandName = $comandFields[-1];

# if no argument input, exit the program

if (@ARGV < 3)
{
   print "Usage: $commandName <TRaP Set Name> <basin Area> <emailList-Array>\n";
   die "No name input - exit script";
}
else
{
   $TRaPSetName = $ARGV[0];
   $basinArea = $ARGV[1];
   for ($j = 2; $j < $#ARGV + 1; $j++)
   {      
     push(@emailList, $ARGV[$j]);
   }

}

print "TRaPSetName is $TRaPSetName, basinArea1 is $basinArea, emailList2 is @emailList\n";

if (!(-s $listFile))
{
   system("cp $templateFile $listFile");
}


print "listFile is $listFile, basinArea is $basinArea\n";

# open(TRAPLIST, "+>> $listFile") || die "Can not open $listFile for reading and writing: $!";
open(TRAPLIST, "< $listFile") || die "Can not open $listFile for reading: $!";
@dataList = <TRAPLIST>;
close(TRAPLIST);

#seek(TRAPLIST, 0, 0) or die "Couldn't seek to the beginning:$!\n";

print "total line number of the list file is $#dataList\n";

open(NEWTRAPLIST, "> $newListFile") || die "Can not open $newListFile for writing: $!";
flock(NEWTRAPLIST, 2);         # and lock it


# initialize the hash table
for ($j = 0; $j < $#emailList+1; $j++)
{
   $isEmailExist{$emailList[$j]} = 0;
}


for ($i = 0; $i < $#dataList+1; $i++)
{
   chomp($dataList[$i]);
   if ($dataList[$i] =~ /$basinArea/)
   {
      print NEWTRAPLIST "$dataList[$i]\n";
      $i++;
     # chomp($dataList[$i]);
      # this is for the TRaP name
      while ($dataList[$i] !~ /ENDNAME-$/)
      {
         chomp($dataList[$i]);
         print NEWTRAPLIST "$dataList[$i]\n";
         $i++;
      }

      print NEWTRAPLIST "$TRaPSetName\n";
      #print NEWTRAPLIST "$namelist1[1]\n";
        
      # this is for the email list
      while ($dataList[$i] !~ /ENDEMAIL-$/)
      {
         chomp($dataList[$i]);
         print NEWTRAPLIST "$dataList[$i]\n";
            
         for ($j = 0; $j < $#emailList+1; $j++)
         {
            if ($emailList[$j] eq $dataList[$i])
            {
               print "$emailList[$j] exist in the list.\n";
               $isEmailExist{$emailList[$j]} = 1;
            }
         } 
         $i++;

      }

      chomp($dataList[$i]);
      
      for ($j = 0; $j < $#emailList+1; $j++)
      {
         if ($isEmailExist{$emailList[$j]} == 0)
         {
            print "$emailList[$j] not exist in the list, add to the TRAP LIST.\n";
            print NEWTRAPLIST "$emailList[$j]\n";
         }
      }
      #print NEWTRAPLIST "$emailList[1]\n";
   }
   print NEWTRAPLIST "$dataList[$i]\n";
}

flock(NEWTRAPLIST, 8);         # and unlock it
close(NEWTRAPLIST) || die "Can not close $newListFile: $!";

rename($listFile, $bakListFile)          or die "can't rename $listFile to $bakListFile: $!";
rename($newListFile, $listFile)          or die "can't rename $newListFile to $listFile: $!";

$enddate=`date`;
print " End of the program $0 at $enddate \n";

