/*********************************************************************** 
File name: dist2.c (dist2-2006.c) 
Author:    Jianbin Yang/RSIS        04/26/2002

Purpose:
        This program read the binary geolocations file of the pass and
        get all the lat/lon of the center of the pass, and calculate
        great-circle distance between each of them and the input point
        (the center of the storm). Then compare the distance with the
        input Maximum cover distance to determine the pass cover the
        sotrm or not.

Usage:  dist <pass file name> <coverDistance> <lat> <lon>
  
Note:
        Calculations assume a spherical Earth with radius 6367 km.  
        (I think this should cause no more than 0.2% error.)


***********************************************************************/


#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <ctype.h>
#include <math.h>


int main (int argc, char *argv[])
{
   FILE  *dataFP;
   FILE  *dataFPW;
   float *midLat;
   float *midLon;

   short numScan;                   /* Number of scans for the pass */
   short *numPtr;

   int   i;
   short   totalNumScan=1920;;

   if (argc != 3)
   {
      printf("%s:two arguments required\n", argv[0]);
      printf("Command line format:\n");
      exit(EXIT_FAILURE);
   } 
     argc = argc - 1;


   numPtr = &numScan;

   /* open input file  */
   if ((dataFP = fopen(argv[1], "rb")) == NULL)
   {
      fprintf(stderr, "Cannot open file %s ... Exiting program\n", argv[1]);
      exit(EXIT_FAILURE);
   } else {
      printf("the file %s is open successfully.\n", argv[1]);
   }


   /* open output file  */
   if ((dataFPW = fopen(argv[2], "rb")) == NULL)
   {
      fprintf(stderr, "file %s is not exist yet\n", argv[2]);
      dataFPW = fopen(argv[2], "wb");
      fwrite(&totalNumScan, 1, sizeof(short), dataFPW);
   } else {
      printf("the file %s is exist.\n",argv[2]);
      fclose(dataFPW);
      dataFPW = fopen(argv[2], "ab");
   }


   if (fread(numPtr, 2, 1, dataFP) != 1)
   {
      printf ("Unable to read the data file.\n");
      exit(EXIT_FAILURE);
   } else {
      printf("the number of scan is %d \n", numScan);
   }

   midLat = (float*) malloc (numScan * sizeof(float));
   midLon = (float*) malloc (numScan * sizeof(float));

   if (fread(midLat, numScan * sizeof(float), 1, dataFP) != 1)
   printf("read lat error.\n");

   if (fread(midLon, numScan * sizeof(float), 1, dataFP) != 1)
   printf("read lon error.\n");
 
   for (i = 0; i < numScan; i++ )
   {
      midLat[i] = midLat[i]*100;
      midLon[i] = midLon[i]*100;
      printf("i midLat midLon %i %f %f\n",i,midLat[i],midLon[i]);
      fwrite(&midLat[i], sizeof(float),1, dataFPW);
      fwrite(&midLon[i], sizeof(float),1, dataFPW);
   }

   fclose(dataFP);
   fclose(dataFPW);
}  


